;----------------------------------------------------------------------------
;		 		Program User Flash
;----------------------------------------------------------------------------
;
program:
	movw	zh:zl, zeroh:zerol	; z = 0x0000
	ldi	xl, low (ProgBuff)
	ldi	xh, high(ProgBuff)
	movw	yh:yl, xh:xl
;---------------------- Receive data for one Page --------------------------
_pro1:
	clt				; end mark received clear
_pro2:
	brts	_pro6
	rcall	getchar
	cpi	a0, COMMAND		; command byte
	brne	_pro3
	rcall	getchar
	cpi	a0, COMMAND
	set				; end mark received set
	brne	_pro4
_pro3:
	st	x+, a0
	cpi	xl, low(ProgBuffEnd)	; since buffer size below 256
	brne	_pro1
;---------------------------------------------------------------------------
_pro4:
	cp	zl, zerol
	cpc	zh, zeroh		; z = 0x0000 ?
	brne	_pro6
;------------------------------ Insert rjmp to boot loader -----------------
	ld	a0, y
	ldd	a1, y+1
	subi	a0, low (BootStart - 0x1001)	; new application jump
	sbci	a1, high(BootStart - 0x1001)
	movw	rjmpapph:rjmpappl, a1:a0	; needed later
	ldi	a0, low (BootStart-1)
	ldi	a1, high(BootStart-1 + 0xC000)  ; = RJMP
	st	y, a0
	std	y+1, a1				; replace by bootloader jump
;----------------------------------------------------------------------------
;               Erase application Flash backward (avoid lock out)
;----------------------------------------------------------------------------
	ldi     zl, low (2*BootStart)
	ldi     zh, high(2*BootStart)
_pro5:
	subi    zl, low (2*PageSize)
	sbci    zh, high(2*PageSize)
	ldi     a0, 0x03                ; Erase command
	out     SPMCSR, a0
	SPM                             ; CPU halted until erase done
	brne    _pro5			; until Z = 0x0000
;----------------------------------------------------------------------------
_pro6:
	brtc	_pro7
	ldi	xl, low (ProgBuffEnd - 2)
	ldi	xh, high(ProgBuffEnd - 2)
	st	x+, rjmpappl
	st	x+, rjmpapph
;---------------------- Fill page buffer ----------------------------------
_pro7:
	subi	zl, low (-PageSize * 2)
	sbci	zh, high(-PageSize * 2)	; point to next page
_pro8:
	sbiw	zh:zl, 2
	ld	r1, -x			; fill buffer downward
	ld	r0, -x
	ldi	a0, 0x01		; fill buffer command
	out	SPMCSR, a0
	SPM
	cpi	xl, low(ProgBuff)
	brne	_pro8
;---------------------- Program page --------------------------------------
	ldi	a0, 0x05		; write page command
	out	SPMCSR, a0
	SPM
;---------------------- Next Page -----------------------------------------
	subi	zl, low (-PageSize * 2)
	sbci	zh, high(-PageSize * 2)	; next page
	brts	_pro9
	ldi	a0, CONTINUE
	rcall	putchar
_pro9:
	cpi	zl, low( 2*BootStart)
	ldi	a1, high(2*BootStart)
	cpc	zh, a1                  ; last page reached ?
	brcs	_pro2
	brts	_pro10
	sbr	flags, 1<<FError	; error, size exceeded
_pro10:
;inlined	ret
;--------------------------------------------------------------------------
