;*************************************************************************
;				Constant definitions
;-------------------------------------------------------------------------
.equ	XTAL		= 7820000	;8MHZ
.equ	BAUD		= 9600
.equ	BOOTSTART	= 57 * PageSize	;whole pages

.equ	COMMAND		= 0xA5		;Command sequence start
.equ	CONTINUE	= 'z'
.equ	SUCCESS		= 'y'
.equ	FAIL		= 'x'
.equ	ANSWER		= 0xA6
;-------------------------------------------------------------------------
;				Using register
;-------------------------------------------------------------------------
.def	zerol		= r2
.def	zeroh		= r3
.def	rjmpappl	= r4		;application start address
.def	rjmpapph	= r5
.def	baudl		= r6		;baud divider
.def	baudh		= r7
;-------------------------------------------------------------------------
.def	a0		= r16		;working registers
.def	a1		= r17
.def	a2		= r18
.def	a3		= r19

.def	flags		= r22
.equ	FError		= 0
.def	twx		= r23		;wait time byte 3
.def	twl		= r24		;wait time
.def	twh		= r25
;-------------------------------------------------------------------------
;				Using SRAM
;-------------------------------------------------------------------------
.dseg
	.org		SRAM_START		;0x60 ... 0xDF
PROGBUFF:		.byte PAGESIZE * 2
PROGBUFFEND:
.cseg
;-------------------------------------------------------------------------
;				Port definitions
;-------------------------------------------------------------------------
.equ	STX_PORT	= PORTB
.equ	STX_DDR		= DDRB
.equ	STX		= PB1
.equ	SRX_PIN		= PINB
.equ	SRX_DDR		= DDRB
.equ	SRX_PORT	= PORTB
.equ	SRX		= PB0
;-------------------------------------------------------------------------
;				Macros
;-------------------------------------------------------------------------
.macro	TXD_0
	cbi	STX_PORT, STX
.endmacro
.macro	TXD_1
	sbi	STX_PORT, STX
.endmacro
.macro	SKIP_RXD_0
	sbic	SRX_PIN, SRX
.endmacro
.macro	SKIP_RXD_1
	sbis	SRX_PIN, SRX
.endmacro
.macro	LED0
	sbi	DDRB, 2
.endmacro
.macro	LED1
	sbi	DDRB, 3
.endmacro
.macro	LED2
	sbi	DDRB, 4
.endmacro
;-------------------------------------------------------------------------
